package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowRouterDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowRouterDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowRouterDetailsLogic {
	return &ShowRouterDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowRouterDetailsLogic) ShowRouterDetails(req *types.ShowRouterDetailsReq) (resp *types.ShowRouterDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowRouterDetailsReq := &openstack.ShowRouterDetailsReq{}
	err = copier.CopyWithOption(ShowRouterDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowRouterDetailsResp, err := l.svcCtx.OpenstackRpc.ShowRouterDetails(l.ctx, ShowRouterDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowRouterDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowRouterDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
